Index: /LMDZ4/trunk/libf/phylmd/phyetat0.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/phyetat0.F	(revision 1000)
+++ /LMDZ4/trunk/libf/phylmd/phyetat0.F	(revision 1001)
@@ -923,23 +563,10 @@
 c Lecture du rayonnement net au sol:
 c
-      ierr = NF_INQ_VARID (nid, "RADS", nvarid)
-      IF (ierr.NE.NF_NOERR) THEN
-         PRINT*, 'phyetat0: Le champ <RADS> est absent'
-         CALL abort
-      ENDIF
-#ifdef NC_DOUBLE
-      ierr = NF_GET_VAR_DOUBLE(nid, nvarid, radsol_glo)
-#else
-      ierr = NF_GET_VAR_REAL(nid, nvarid, radsol_glo)
-#endif
-      IF (ierr.NE.NF_NOERR) THEN
-         PRINT*, 'phyetat0: Lecture echouee pour <RADS>'
-         CALL abort
-      ENDIF
-      xmin = 1.0E+20
-      xmax = -1.0E+20
-      DO i = 1, klon_glo
-         xmin = MIN(radsol_glo(i),xmin)
-         xmax = MAX(radsol_glo(i),xmax)
+      CALL get_field("RADS",radsol)
+      xmin = 1.0E+20
+      xmax = -1.0E+20
+      DO i = 1, klon
+         xmin = MIN(radsol(i),xmin)
+         xmax = MAX(radsol(i),xmax)
       ENDDO
       PRINT*,'Rayonnement net au sol radsol:', xmin, xmax
@@ -948,6 +575,6 @@
 c
 c
-      ierr = NF_INQ_VARID (nid, "RUG", nvarid)
-      IF (ierr.NE.NF_NOERR) THEN
+      CALL get_field("RUG",frugs(:,1),found)
+      IF (.NOT. found) THEN
          PRINT*, 'phyetat0: Le champ <RUG> est absent'
          PRINT*, '          Mais je vais essayer de lire RUG**'
@@ -958,21 +585,8 @@
            ENDIF
            WRITE(str2,'(i2.2)') nsrf
-           ierr = NF_INQ_VARID (nid, "RUG"//str2, nvarid)
-           IF (ierr.NE.NF_NOERR) THEN
-              PRINT*, "phyetat0: Le champ <RUG"//str2//"> est absent"
-              CALL abort
-           ENDIF
-#ifdef NC_DOUBLE
-           ierr = NF_GET_VAR_DOUBLE(nid, nvarid, frugs(1,nsrf))
-#else
-           ierr = NF_GET_VAR_REAL(nid, nvarid, frugs(1,nsrf))
-#endif
-           IF (ierr.NE.NF_NOERR) THEN
-             PRINT*, "phyetat0: Lecture echouee pour <RUG"//str2//">"
-             CALL abort
-           ENDIF
+           CALL get_field("RUG"//str2,frugs(:,nsrf))
            xmin = 1.0E+20
            xmax = -1.0E+20
-           DO i = 1, klon_glo
+           DO i = 1, klon
               xmin = MIN(frugs(i,nsrf),xmin)
               xmax = MAX(frugs(i,nsrf),xmax)
@@ -983,16 +597,7 @@
          PRINT*, 'phyetat0: Le champ <RUG> est present'
          PRINT*, '          J ignore donc les autres RUG**'
-#ifdef NC_DOUBLE
-         ierr = NF_GET_VAR_DOUBLE(nid, nvarid, frugs(1,1))
-#else
-         ierr = NF_GET_VAR_REAL(nid, nvarid, frugs(1,1))
-#endif
-         IF (ierr.NE.NF_NOERR) THEN
-            PRINT*, "phyetat0: Lecture echouee pour <RUG>"
-            CALL abort
-         ENDIF
          xmin = 1.0E+20
          xmax = -1.0E+20
-         DO i = 1, klon_glo
+         DO i = 1, klon
             xmin = MIN(frugs(i,1),xmin)
             xmax = MAX(frugs(i,1),xmax)
@@ -1000,5 +605,5 @@
          PRINT*,'rugosite <RUG>', xmin, xmax
          DO nsrf = 2, nbsrf
-         DO i = 1, klon_glo
+         DO i = 1, klon
             frugs(i,nsrf) = frugs(i,1)
          ENDDO
@@ -1009,6 +614,6 @@
 c Lecture de l'age de la neige:
 c
-      ierr = NF_INQ_VARID (nid, "AGESNO", nvarid)
-      IF (ierr.NE.NF_NOERR) THEN
+      CALL get_field("AGESNO",agesno(:,1),found)
+      IF (.NOT. found) THEN
          PRINT*, 'phyetat0: Le champ <AGESNO> est absent'
          PRINT*, '          Mais je vais essayer de lire AGESNO**'
@@ -1019,21 +624,12 @@
            ENDIF
            WRITE(str2,'(i2.2)') nsrf
-           ierr = NF_INQ_VARID (nid, "AGESNO"//str2, nvarid)
-           IF (ierr.NE.NF_NOERR) THEN
+           CALL get_field("AGESNO"//str2,agesno(:,nsrf),found)
+           IF (.NOT. found) THEN
               PRINT*, "phyetat0: Le champ <AGESNO"//str2//"> est absent"
               agesno = 50.0
            ENDIF
-#ifdef NC_DOUBLE
-           ierr = NF_GET_VAR_DOUBLE(nid, nvarid, agesno(1,nsrf))
-#else
-           ierr = NF_GET_VAR_REAL(nid, nvarid, agesno(1,nsrf))
-#endif
-           IF (ierr.NE.NF_NOERR) THEN
-             PRINT*, "phyetat0: Lecture echouee pour <AGESNO"//str2//">"
-             CALL abort
-           ENDIF
            xmin = 1.0E+20
            xmax = -1.0E+20
-           DO i = 1, klon_glo
+           DO i = 1, klon
               xmin = MIN(agesno(i,nsrf),xmin)
               xmax = MAX(agesno(i,nsrf),xmax)
@@ -1044,16 +640,7 @@
          PRINT*, 'phyetat0: Le champ <AGESNO> est present'
          PRINT*, '          J ignore donc les autres AGESNO**'
-#ifdef NC_DOUBLE
-         ierr = NF_GET_VAR_DOUBLE(nid, nvarid, agesno(1,1))
-#else
-         ierr = NF_GET_VAR_REAL(nid, nvarid, agesno(1,1))
-#endif
-         IF (ierr.NE.NF_NOERR) THEN
-            PRINT*, "phyetat0: Lecture echouee pour <AGESNO>"
-            CALL abort
-         ENDIF
          xmin = 1.0E+20
          xmax = -1.0E+20
-         DO i = 1, klon_glo
+         DO i = 1, klon
             xmin = MIN(agesno(i,1),xmin)
             xmax = MAX(agesno(i,1),xmax)
@@ -1061,5 +648,5 @@
          PRINT*,'Age de la neige <AGESNO>', xmin, xmax
          DO nsrf = 2, nbsrf
-         DO i = 1, klon_glo
+         DO i = 1, klon
             agesno(i,nsrf) = agesno(i,1)
          ENDDO
@@ -1068,267 +655,126 @@
 
 c
-      ierr = NF_INQ_VARID (nid, "ZMEA", nvarid)
-      IF (ierr.NE.NF_NOERR) THEN
-         PRINT*, 'phyetat0: Le champ <ZMEA> est absent'
-         CALL abort
-      ENDIF
-#ifdef NC_DOUBLE
-      ierr = NF_GET_VAR_DOUBLE(nid, nvarid, zmea_glo)
-#else
-      ierr = NF_GET_VAR_REAL(nid, nvarid, zmea_glo)
-#endif
-      IF (ierr.NE.NF_NOERR) THEN
-         PRINT*, 'phyetat0: Lecture echouee pour <ZMEA>'
-         CALL abort
-      ENDIF
-      xmin = 1.0E+20
-      xmax = -1.0E+20
-      DO i = 1, klon_glo
-         xmin = MIN(zmea_glo(i),xmin)
-         xmax = MAX(zmea_glo(i),xmax)
+      CALL get_field("ZMEA", zmea)
+      xmin = 1.0E+20
+      xmax = -1.0E+20
+      DO i = 1, klon
+         xmin = MIN(zmea(i),xmin)
+         xmax = MAX(zmea(i),xmax)
       ENDDO
       PRINT*,'OROGRAPHIE SOUS-MAILLE zmea:', xmin, xmax
 c
 c
-      ierr = NF_INQ_VARID (nid, "ZSTD", nvarid)
-      IF (ierr.NE.NF_NOERR) THEN
-         PRINT*, 'phyetat0: Le champ <ZSTD> est absent'
-         CALL abort
-      ENDIF
-#ifdef NC_DOUBLE
-      ierr = NF_GET_VAR_DOUBLE(nid, nvarid, zstd_glo)
-#else
-      ierr = NF_GET_VAR_REAL(nid, nvarid, zstd_glo)
-#endif
-      IF (ierr.NE.NF_NOERR) THEN
-         PRINT*, 'phyetat0: Lecture echouee pour <ZSTD>'
-         CALL abort
-      ENDIF
-      xmin = 1.0E+20
-      xmax = -1.0E+20
-      DO i = 1, klon_glo
-         xmin = MIN(zstd_glo(i),xmin)
-         xmax = MAX(zstd_glo(i),xmax)
+      CALL get_field("ZSTD",zstd)
+      xmin = 1.0E+20
+      xmax = -1.0E+20
+      DO i = 1, klon
+         xmin = MIN(zstd(i),xmin)
+         xmax = MAX(zstd(i),xmax)
       ENDDO
       PRINT*,'OROGRAPHIE SOUS-MAILLE zstd:', xmin, xmax
 c
 c
-      ierr = NF_INQ_VARID (nid, "ZSIG", nvarid)
-      IF (ierr.NE.NF_NOERR) THEN
-         PRINT*, 'phyetat0: Le champ <ZSIG> est absent'
-         CALL abort
-      ENDIF
-#ifdef NC_DOUBLE
-      ierr = NF_GET_VAR_DOUBLE(nid, nvarid, zsig_glo)
-#else
-      ierr = NF_GET_VAR_REAL(nid, nvarid, zsig_glo)
-#endif
-      IF (ierr.NE.NF_NOERR) THEN
-         PRINT*, 'phyetat0: Lecture echouee pour <ZSIG>'
-         CALL abort
-      ENDIF
-      xmin = 1.0E+20
-      xmax = -1.0E+20
-      DO i = 1, klon_glo
-         xmin = MIN(zsig_glo(i),xmin)
-         xmax = MAX(zsig_glo(i),xmax)
+      CALL get_field("ZSIG",zsig)
+      xmin = 1.0E+20
+      xmax = -1.0E+20
+      DO i = 1, klon
+         xmin = MIN(zsig(i),xmin)
+         xmax = MAX(zsig(i),xmax)
       ENDDO
       PRINT*,'OROGRAPHIE SOUS-MAILLE zsig:', xmin, xmax
 c
 c
-      ierr = NF_INQ_VARID (nid, "ZGAM", nvarid)
-      IF (ierr.NE.NF_NOERR) THEN
-         PRINT*, 'phyetat0: Le champ <ZGAM> est absent'
-         CALL abort
-      ENDIF
-#ifdef NC_DOUBLE
-      ierr = NF_GET_VAR_DOUBLE(nid, nvarid, zgam_glo)
-#else
-      ierr = NF_GET_VAR_REAL(nid, nvarid, zgam_glo)
-#endif
-      IF (ierr.NE.NF_NOERR) THEN
-         PRINT*, 'phyetat0: Lecture echouee pour <ZGAM>'
-         CALL abort
-      ENDIF
-      xmin = 1.0E+20
-      xmax = -1.0E+20
-      DO i = 1, klon_glo
-         xmin = MIN(zgam_glo(i),xmin)
-         xmax = MAX(zgam_glo(i),xmax)
+      CALL get_field("ZGAM",zgam)
+      xmin = 1.0E+20
+      xmax = -1.0E+20
+      DO i = 1, klon
+         xmin = MIN(zgam(i),xmin)
+         xmax = MAX(zgam(i),xmax)
       ENDDO
       PRINT*,'OROGRAPHIE SOUS-MAILLE zgam:', xmin, xmax
 c
 c
-      ierr = NF_INQ_VARID (nid, "ZTHE", nvarid)
-      IF (ierr.NE.NF_NOERR) THEN
-         PRINT*, 'phyetat0: Le champ <ZTHE> est absent'
-         CALL abort
-      ENDIF
-#ifdef NC_DOUBLE
-      ierr = NF_GET_VAR_DOUBLE(nid, nvarid, zthe_glo)
-#else
-      ierr = NF_GET_VAR_REAL(nid, nvarid, zthe_glo)
-#endif
-      IF (ierr.NE.NF_NOERR) THEN
-         PRINT*, 'phyetat0: Lecture echouee pour <ZTHE>'
-         CALL abort
-      ENDIF
-      xmin = 1.0E+20
-      xmax = -1.0E+20
-      DO i = 1, klon_glo
-         xmin = MIN(zthe_glo(i),xmin)
-         xmax = MAX(zthe_glo(i),xmax)
+      CALL get_field("ZTHE",zthe)
+      xmin = 1.0E+20
+      xmax = -1.0E+20
+      DO i = 1, klon
+         xmin = MIN(zthe(i),xmin)
+         xmax = MAX(zthe(i),xmax)
       ENDDO
       PRINT*,'OROGRAPHIE SOUS-MAILLE zthe:', xmin, xmax
 c
 c
-      ierr = NF_INQ_VARID (nid, "ZPIC", nvarid)
-      IF (ierr.NE.NF_NOERR) THEN
-         PRINT*, 'phyetat0: Le champ <ZPIC> est absent'
-         CALL abort
-      ENDIF
-#ifdef NC_DOUBLE
-      ierr = NF_GET_VAR_DOUBLE(nid, nvarid, zpic_glo)
-#else
-      ierr = NF_GET_VAR_REAL(nid, nvarid, zpic_glo)
-#endif
-      IF (ierr.NE.NF_NOERR) THEN
-         PRINT*, 'phyetat0: Lecture echouee pour <ZPIC>'
-         CALL abort
-      ENDIF
-      xmin = 1.0E+20
-      xmax = -1.0E+20
-      DO i = 1, klon_glo
-         xmin = MIN(zpic_glo(i),xmin)
-         xmax = MAX(zpic_glo(i),xmax)
+      CALL get_field("ZPIC",zpic)
+      xmin = 1.0E+20
+      xmax = -1.0E+20
+      DO i = 1, klon
+         xmin = MIN(zpic(i),xmin)
+         xmax = MAX(zpic(i),xmax)
       ENDDO
       PRINT*,'OROGRAPHIE SOUS-MAILLE zpic:', xmin, xmax
 c
-      ierr = NF_INQ_VARID (nid, "ZVAL", nvarid)
-      IF (ierr.NE.NF_NOERR) THEN
-         PRINT*, 'phyetat0: Le champ <ZVAL> est absent'
-         CALL abort
-      ENDIF
-#ifdef NC_DOUBLE
-      ierr = NF_GET_VAR_DOUBLE(nid, nvarid, zval_glo)
-#else
-      ierr = NF_GET_VAR_REAL(nid, nvarid, zval_glo)
-#endif
-      IF (ierr.NE.NF_NOERR) THEN
-         PRINT*, 'phyetat0: Lecture echouee pour <ZVAL>'
-         CALL abort
-      ENDIF
-      xmin = 1.0E+20
-      xmax = -1.0E+20
-      DO i = 1, klon_glo
-         xmin = MIN(zval_glo(i),xmin)
-         xmax = MAX(zval_glo(i),xmax)
+      CALL get_field("ZVAL",zval)
+      xmin = 1.0E+20
+      xmax = -1.0E+20
+      DO i = 1, klon
+         xmin = MIN(zval(i),xmin)
+         xmax = MAX(zval(i),xmax)
       ENDDO
       PRINT*,'OROGRAPHIE SOUS-MAILLE zval:', xmin, xmax
 c
 c
-      ierr = NF_INQ_VARID (nid, "RUGSREL", nvarid)
-      IF (ierr.NE.NF_NOERR) THEN
-         PRINT*, 'phyetat0: Le champ <RUGSREL> est absent'
-         CALL abort
-      ENDIF
-#ifdef NC_DOUBLE
-      ierr = NF_GET_VAR_DOUBLE(nid, nvarid, rugsrel_glo)
-#else
-      ierr = NF_GET_VAR_REAL(nid, nvarid, rugsrel_glo)
-#endif
-      IF (ierr.NE.NF_NOERR) THEN
-         PRINT*, 'phyetat0: Lecture echouee pour <RUGSREL>'
-         CALL abort
-      ENDIF
-      xmin = 1.0E+20
-      xmax = -1.0E+20
-      DO i = 1, klon_glo
-         xmin = MIN(rugsrel_glo(i),xmin)
-         xmax = MAX(rugsrel_glo(i),xmax)
+      CALL get_field("RUGSREL",rugoro)
+      xmin = 1.0E+20
+      xmax = -1.0E+20
+      DO i = 1, klon
+         xmin = MIN(rugoro(i),xmin)
+         xmax = MAX(rugoro(i),xmax)
       ENDDO
       PRINT*,'Rugosite relief (ecart-type) rugsrel:', xmin, xmax
 c
 c
-      ancien_ok_glo = .TRUE.
-c
-      ierr = NF_INQ_VARID (nid, "TANCIEN", nvarid)
-      IF (ierr.NE.NF_NOERR) THEN
+     
+c
+      ancien_ok = .TRUE.
+
+      CALL get_field("TANCIEN",t_ancien,found)
+      IF (.NOT. found) THEN
          PRINT*, "phyetat0: Le champ <TANCIEN> est absent"
          PRINT*, "Depart legerement fausse. Mais je continue"
-         ancien_ok_glo = .FALSE.
-      ELSE
-#ifdef NC_DOUBLE
-         ierr = NF_GET_VAR_DOUBLE(nid, nvarid, t_ancien_glo)
-#else
-         ierr = NF_GET_VAR_REAL(nid, nvarid, t_ancien_glo)
-#endif
-         IF (ierr.NE.NF_NOERR) THEN
-            PRINT*, "phyetat0: Lecture echouee pour <TANCIEN>"
-            CALL abort
-         ENDIF
-      ENDIF
-c
-      ierr = NF_INQ_VARID (nid, "QANCIEN", nvarid)
-      IF (ierr.NE.NF_NOERR) THEN
+         ancien_ok = .FALSE.
+      ENDIF
+
+
+      CALL get_field("QANCIEN",q_ancien,found)
+      IF (.NOT. found) THEN
          PRINT*, "phyetat0: Le champ <QANCIEN> est absent"
          PRINT*, "Depart legerement fausse. Mais je continue"
-         ancien_ok_glo = .FALSE.
-      ELSE
-#ifdef NC_DOUBLE
-         ierr = NF_GET_VAR_DOUBLE(nid, nvarid, q_ancien_glo)
-#else
-         ierr = NF_GET_VAR_REAL(nid, nvarid, q_ancien_glo)
-#endif
-         IF (ierr.NE.NF_NOERR) THEN
-            PRINT*, "phyetat0: Lecture echouee pour <QANCIEN>"
-            CALL abort
-         ENDIF
-      ENDIF
-c
-      clwcon_glo=0.
-      ierr = NF_INQ_VARID (nid, "CLWCON", nvarid)
-      IF (ierr.NE.NF_NOERR) THEN
+         ancien_ok = .FALSE.
+      ENDIF
+
+c
+
+      clwcon=0.
+      CALL get_field("CLWCON",clwcon(:,1),found)
+      IF (.NOT. found) THEN
          PRINT*, "phyetat0: Le champ CLWCON est absent"
          PRINT*, "Depart legerement fausse. Mais je continue"
-c        clwcon_glo = 0.
-      ELSE
-#ifdef NC_DOUBLE
-         ierr = NF_GET_VAR_DOUBLE(nid, nvarid, clwcon_glo)
-#else
-         ierr = NF_GET_VAR_REAL(nid, nvarid, clwcon_glo)
-#endif
-         IF (ierr.NE.NF_NOERR) THEN
-            PRINT*, "phyetat0: Lecture echouee pour <CLWCON>"
-            CALL abort
-         ENDIF
-      ENDIF
-      xmin = 1.0E+20
-      xmax = -1.0E+20
-      xmin = MINval(clwcon_glo)
-      xmax = MAXval(clwcon_glo)
+      ENDIF
+      xmin = 1.0E+20
+      xmax = -1.0E+20
+      xmin = MINval(clwcon)
+      xmax = MAXval(clwcon)
       PRINT*,'Eau liquide convective (ecart-type) clwcon:', xmin, xmax
 c
-      rnebcon_glo = 0.
-      ierr = NF_INQ_VARID (nid, "RNEBCON", nvarid)
-      IF (ierr.NE.NF_NOERR) THEN
+      rnebcon = 0.
+      CALL get_field("RNEBCON",rnebcon(:,1),found)
+      IF (.NOT. found) THEN
          PRINT*, "phyetat0: Le champ RNEBCON est absent"
          PRINT*, "Depart legerement fausse. Mais je continue"
-c        rnebcon_glo = 0.
-      ELSE
-#ifdef NC_DOUBLE
-         ierr = NF_GET_VAR_DOUBLE(nid, nvarid, rnebcon_glo)
-#else
-         ierr = NF_GET_VAR_REAL(nid, nvarid, rnebcon_glo)
-#endif
-         IF (ierr.NE.NF_NOERR) THEN
-            PRINT*, "phyetat0: Lecture echouee pour <RNEBCON>"
-            CALL abort
-         ENDIF
-      ENDIF
-      xmin = 1.0E+20
-      xmax = -1.0E+20
-      xmin = MINval(rnebcon_glo)
-      xmax = MAXval(rnebcon_glo)
+      ENDIF
+      xmin = 1.0E+20
+      xmax = -1.0E+20
+      xmin = MINval(rnebcon)
+      xmax = MAXval(rnebcon)
       PRINT*,'Nebulosite convective (ecart-type) rnebcon:', xmin, xmax
 
@@ -1336,44 +782,23 @@
 c Lecture ratqs
 c
-      ratqs_glo=0.
-      ierr = NF_INQ_VARID (nid, "RATQS", nvarid)
-      IF (ierr.NE.NF_NOERR) THEN
+      ratqs=0.
+      CALL get_field("RATQS",ratqs(:,1),found)
+      IF (.NOT. found) THEN
          PRINT*, "phyetat0: Le champ <RATQS> est absent"
          PRINT*, "Depart legerement fausse. Mais je continue"
-         ratqs_glo = 0.
-      ELSE
-#ifdef NC_DOUBLE
-         ierr = NF_GET_VAR_DOUBLE(nid, nvarid, ratqs_glo)
-#else
-         ierr = NF_GET_VAR_REAL(nid, nvarid, ratqs_glo)
-#endif
-         IF (ierr.NE.NF_NOERR) THEN
-            PRINT*, "phyetat0: Lecture echouee pour <RATQS>"
-            CALL abort
-         ENDIF
-      ENDIF
-      xmin = 1.0E+20
-      xmax = -1.0E+20
-      xmin = MINval(ratqs_glo)
-      xmax = MAXval(ratqs_glo)
+      ENDIF
+      xmin = 1.0E+20
+      xmax = -1.0E+20
+      xmin = MINval(ratqs)
+      xmax = MAXval(ratqs)
       PRINT*,'(ecart-type) ratqs:', xmin, xmax
 c
 c Lecture run_off_lic_0
 c
-      ierr = NF_INQ_VARID (nid, "RUNOFFLIC0", nvarid)
-      IF (ierr.NE.NF_NOERR) THEN
+      CALL get_field("RUNOFFLIC0",run_off_lic_0,found)
+      IF (.NOT. found) THEN
          PRINT*, "phyetat0: Le champ <RUNOFFLIC0> est absent"
          PRINT*, "Depart legerement fausse. Mais je continue"
          run_off_lic_0 = 0.
-      ELSE
-#ifdef NC_DOUBLE
-         ierr = NF_GET_VAR_DOUBLE(nid, nvarid, run_off_lic_0)
-#else
-         ierr = NF_GET_VAR_REAL(nid, nvarid, run_off_lic_0)
-#endif
-         IF (ierr.NE.NF_NOERR) THEN
-            PRINT*, "phyetat0: Lecture echouee pour <RUNOFFLIC0>"
-            CALL abort
-         ENDIF
       ENDIF
       xmin = 1.0E+20
